VERSION 2.00
Begin Form tswitch 
   Caption         =   "Task Switcher"
   ClientHeight    =   1680
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   4200
   Height          =   2085
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   1680
   ScaleWidth      =   4200
   Top             =   1140
   Width           =   4320
   Begin CommandButton cmdLoad 
      Caption         =   "Load App"
      Height          =   345
      Left            =   1500
      TabIndex        =   1
      Top             =   1020
      Width           =   1005
   End
   Begin TextBox Text1 
      Height          =   285
      Left            =   1500
      TabIndex        =   2
      Top             =   480
      Width           =   1965
   End
   Begin Label lbl1 
      Alignment       =   1  'Right Justify
      Caption         =   "App Name:"
      Height          =   225
      Left            =   330
      TabIndex        =   0
      Top             =   510
      Width           =   1095
   End
End
'
' TSwitch will show how to check if an app is running, switch to it, or
' if not found start it up,  all using only the program EXE name.
' The first instance of the program will be selected if more
' then one copy of target app is running. Use full file name: yourapp.exe

' Ken Rackowski 4/14/94

'Declare constants used by GetWindow
    Const GW_CHILD = 5
    Const GW_HWNDFIRST = 0
    Const GW_HWNDLAST = 1
    Const GW_HWNDNEXT = 2
    Const GW_HWNDPREV = 3
    Const GW_OWNER = 4

'Declare constants used by GetClassWindow
    Const gcw_hmodule = (-16)
 
'Declare constants used by Show Window
    Const SW_RESTORE = 9

'Declare Functions
    Declare Function GetWindow Lib "user" (ByVal hWnd%, ByVal wCmd%) As Integer
    Declare Function GetWindowText Lib "user" (ByVal hWnd%, ByVal lpString$, ByVal nMaxCount%) As Integer
    Declare Function GetWindowTextLength Lib "user" (ByVal hWnd%) As Integer
    Declare Function GetClassWord Lib "User" (ByVal hWnd%, ByVal nIndex%) As Integer
    Declare Function GetModuleHandle Lib "Kernel" (ByVal lpModuleName$) As Integer
    Declare Function ShowWindow Lib "User" (ByVal hWnd%, ByVal nCmdShow%) As Integer

Sub cmdLoad_Click ()
    Dim Apptest%, cHand%, Mhand%
    Dim currwnd%, length%, win%
    Dim txt$, exename$
   
    exename$ = Text1.Text

'Make sure something is in text box

    If Len(exename$) < 1 Then
        Beep
        MsgBox "Please Enter FileName", 16, "TaskSwitch"
        Exit Sub
    End If

'See if this EXE is loaded
   
    Mhand% = GetModuleHandle(exename$)
    If Mhand% = 0 Then
        On Error GoTo BadApp
        x% = Shell(exename$, 1)
    Else
        
        win% = TSwitch.hWnd
        'Get the hWnd of the first item in the master list
        'so we can process the task list entries (top-level only).
        currwnd = GetWindow%(win%, GW_HWNDFIRST)
        
        'Loop while the hWnd returned by GetWindow is valid.
        Apptest% = False
        While currwnd <> 0 And Not Apptest%
    
            'Get Handle of current Window (hInstance)
            cHand% = GetClassWord(currwnd, gcw_hmodule)
    
            ' Compare current window instance with exe module instance
            If cHand% = Mhand% Then
                'Get the length of task name identified by CurrWnd in the list.
                length = GetWindowTextLength(currwnd)
                'Get task name of the task in the master list.
                listitem$ = Space$(length + 1)
                length = GetWindowText(currwnd, listitem$, length + 1)
                Apptest% = True
            Else
                'Get the next task list item in the master list.
                currwnd = GetWindow(currwnd, GW_HWNDNEXT)
            End If
    
            'Process Windows events.
            x% = DoEvents()
        Wend
    
        ' if we found the instance switch to the app
        If Apptest% Then
            'AppActivate listitem$
             x% = ShowWindow(currwnd, SW_RESTORE)
             AppActivate listitem$
        End If
    End If
Exit Sub

BadApp:
    Beep
    MsgBox "Unable to load " & exename$ & " Please check Filename", 16, "TaskSwitch"
    Resume Next
End Sub

